/* bcv.h
**
** Convert a char buffer content (big endian) to a value of an integer type.
**
*/
#ifndef _BCV_H
#define _BCV_H

#include <sys/types.h>

/* convert buffer content to an integer */
#define DEFCVF(b2i, i2b, type) \
    static __inline__ type b2i (char *_b) { \
	type res; size_t ix; unsigned char *b = (unsigned char *) _b; \
	res = (type) 0; \
	for (ix=0; ix < sizeof(type); ++ix) { res<<=8; res|=(type) b[ix]; } \
	return res; \
    } \
    static __inline__ void i2b (type i, char *b) { \
	int ix; \
	for (ix=sizeof(type)-1; ix >= 0; --ix) { b[ix]=(char)(i&0xff); i>>=8; }\
    }

#endif /* defined(_BCV_H) */
